kind: pipeline
name: build_amd64
type: docker

node:
  architecture: amd64

platform: 
  arch: amd64

steps:
  - name: buildBaseX64
    image: harbor.gretzki.ddns.net/gcrio-cache/kaniko-project/executor:debug
    environment:
      BASE_PROJECT_X64: containerruntimeglobal_base_x64
      HARBOR_HOST: harbor.gretzki.ddns.net
      HARBOR_PROJECT: containerruntimeglobal
      HARBOR_USERNAME:
        from_secret: harbor_user
      HARBOR_PASSWORD:
        from_secret: harbor_password
    commands:
      - mkdir -p /kaniko/.docker
      - AUTH=$(echo -n "$HARBOR_USERNAME:$HARBOR_PASSWORD" | base64 -w 0)
      - echo "{\"auths\":{\"$HARBOR_HOST\":{\"auth\":\"$AUTH\"}}}" > /kaniko/.docker/config.json
      - TIMESTAMP=$(date +%Y%m%d%H%M%S)
      - /kaniko/executor
        --context "./"
        --dockerfile ./docker/Dockerfile_X64
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$BASE_PROJECT_X64:latest"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$BASE_PROJECT_X64:24.04"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$BASE_PROJECT_X64:$TIMESTAMP-NIGHTLY"
  
  - name: buildSemgrep
    image: harbor.gretzki.ddns.net/gcrio-cache/kaniko-project/executor:debug
    environment:
      BASE_PROJECT_X64: containerruntimeglobal_base_x64:latest
      TARGET_PROJECT_NAME: containerruntimeglobal_x64_semgrep
      DEFAULT_TAG: 24.04_8.0.8
      HARBOR_HOST: harbor.gretzki.ddns.net
      HARBOR_PROJECT: containerruntimeglobal
      HARBOR_USERNAME:
        from_secret: harbor_user
      HARBOR_PASSWORD:
        from_secret: harbor_password
    commands:
      - mkdir -p /kaniko/.docker
      - AUTH=$(echo -n "$HARBOR_USERNAME:$HARBOR_PASSWORD" | base64 -w 0)
      - echo "{\"auths\":{\"$HARBOR_HOST\":{\"auth\":\"$AUTH\"}}}" > /kaniko/.docker/config.json
      - TIMESTAMP=$(date +%Y%m%d%H%M%S)
      - /kaniko/executor
        --context "./"
        --dockerfile ./docker/Dockerfile_X64_Semgrep
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$DEFAULT_TAG"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$TIMESTAMP-NIGHTLY"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:latest"
        --build-arg IMAGE=$HARBOR_HOST/$HARBOR_PROJECT/$BASE_PROJECT_X64
    depends_on: [ buildBaseX64 ]
    
    
  - name: buildSemgrep-Gitea
    image: harbor.gretzki.ddns.net/gcrio-cache/kaniko-project/executor:debug
    environment:
      TARGET_PROJECT_NAME: containerruntimeglobal_x64_semgrep_gitea
      DEFAULT_TAG: 24.04_8.0.8
      HARBOR_HOST: harbor.gretzki.ddns.net
      HARBOR_PROJECT: containerruntimeglobal
      HARBOR_USERNAME:
        from_secret: harbor_user
      HARBOR_PASSWORD:
        from_secret: harbor_password
    commands:
      - mkdir -p /kaniko/.docker
      - AUTH=$(echo -n "$HARBOR_USERNAME:$HARBOR_PASSWORD" | base64 -w 0)
      - echo "{\"auths\":{\"$HARBOR_HOST\":{\"auth\":\"$AUTH\"}}}" > /kaniko/.docker/config.json
      - TIMESTAMP=$(date +%Y%m%d%H%M%S)
      - /kaniko/executor
        --context "./"
        --dockerfile ./docker/Dockerfile_X64_Semgrep
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$DEFAULT_TAG"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$TIMESTAMP-NIGHTLY"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:latest"
        --build-arg IMAGE=$HARBOR_HOST/docker-cache/gitea/runner-images:ubuntu-latest-slim

  - name: deploySdk
    image: harbor.gretzki.ddns.net/gcrio-cache/kaniko-project/executor:debug
    environment:
      HARBOR_HOST: harbor.gretzki.ddns.net
      HARBOR_PROJECT: containerruntimeglobal
      HARBOR_USERNAME:
        from_secret: harbor_user
      HARBOR_PASSWORD:
        from_secret: harbor_password
      TARGET_PROJECT_NAME: containerruntimeglobal_x64_dotnet_build
      DEFAULT_TAG: 24.04_8.0.8
    commands:
      - mkdir -p /kaniko/.docker
      - AUTH=$(echo -n "$HARBOR_USERNAME:$HARBOR_PASSWORD" | base64 -w 0)
      - echo "{\"auths\":{\"$HARBOR_HOST\":{\"auth\":\"$AUTH\"}}}" > /kaniko/.docker/config.json
      - TIMESTAMP=$(date +%Y%m%d%H%M%S)
      - /kaniko/executor
        --context "./"
        --dockerfile ./docker/Dockerfile_X64_Dotnet_SDK
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$DEFAULT_TAG"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$TIMESTAMP-NIGHTLY"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:latest"
        --build-arg IMAGE=harbor.gretzki.ddns.net/containerruntimeglobal/containerruntimeglobal_base_x64:24.04
        --build-arg download=https://dwl.gretzki.ddns.net/downloads/dotnet-sdk-8.0.402-linux-x64.tar.gz
    depends_on: [ buildBaseX64 ]
    
  - name: deploySdk-Gitea
    image: harbor.gretzki.ddns.net/gcrio-cache/kaniko-project/executor:debug
    environment:
      HARBOR_HOST: harbor.gretzki.ddns.net
      HARBOR_PROJECT: containerruntimeglobal
      HARBOR_USERNAME:
        from_secret: harbor_user
      HARBOR_PASSWORD:
        from_secret: harbor_password
      TARGET_PROJECT_NAME: containerruntimeglobal_x64_dotnet_build_gitea
      DEFAULT_TAG: 24.04_8.0.8
    commands:
      - mkdir -p /kaniko/.docker
      - AUTH=$(echo -n "$HARBOR_USERNAME:$HARBOR_PASSWORD" | base64 -w 0)
      - echo "{\"auths\":{\"$HARBOR_HOST\":{\"auth\":\"$AUTH\"}}}" > /kaniko/.docker/config.json
      - TIMESTAMP=$(date +%Y%m%d%H%M%S)
      - /kaniko/executor
        --context "./"
        --dockerfile ./docker/Dockerfile_X64_Dotnet_SDK
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$DEFAULT_TAG"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$TIMESTAMP-NIGHTLY"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:latest"
        --build-arg IMAGE=$HARBOR_HOST/docker-cache/gitea/runner-images:ubuntu-latest-slim
        --build-arg download=https://dwl.gretzki.ddns.net/downloads/dotnet-sdk-8.0.402-linux-x64.tar.gz
    
  - name: deployBFlat
    image: harbor.gretzki.ddns.net/gcrio-cache/kaniko-project/executor:debug
    environment:
      HARBOR_HOST: harbor.gretzki.ddns.net
      HARBOR_PROJECT: containerruntimeglobal
      HARBOR_USERNAME:
        from_secret: harbor_user
      HARBOR_PASSWORD:
        from_secret: harbor_password
      TARGET_PROJECT_NAME: containerruntimeglobal_x64_bflat
      DEFAULT_TAG: 24.04_8.0.8
    commands:
      - mkdir -p /kaniko/.docker
      - AUTH=$(echo -n "$HARBOR_USERNAME:$HARBOR_PASSWORD" | base64 -w 0)
      - echo "{\"auths\":{\"$HARBOR_HOST\":{\"auth\":\"$AUTH\"}}}" > /kaniko/.docker/config.json
      - TIMESTAMP=$(date +%Y%m%d%H%M%S)
      - /kaniko/executor
        --context "./"
        --dockerfile ./docker/Dockerfile_X64_Bflat
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$DEFAULT_TAG"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$TIMESTAMP-NIGHTLY"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:latest"
        --build-arg IMAGE=harbor.gretzki.ddns.net/docker-cache/debian:latest
        --build-arg BFLAT=https://dwl.gretzki.ddns.net/downloads/bflat-8.0.2-linux-glibc-x64.tar.gz
        --build-arg UPX=https://dwl.gretzki.ddns.net/downloads/upx-4.2.3-amd64_linux.tar.xz
    depends_on: [ buildBaseX64 ]      

  - name: deployDotnetBFlat
    image: harbor.gretzki.ddns.net/gcrio-cache/kaniko-project/executor:debug
    environment:
      HARBOR_HOST: harbor.gretzki.ddns.net
      HARBOR_PROJECT: containerruntimeglobal
      HARBOR_USERNAME:
        from_secret: harbor_user
      HARBOR_PASSWORD:
        from_secret: harbor_password
      TARGET_PROJECT_NAME: containerruntimeglobal_x64_dotnet_bflat
      DEFAULT_TAG: 24.04_8.0.8
    commands:
      - mkdir -p /kaniko/.docker
      - AUTH=$(echo -n "$HARBOR_USERNAME:$HARBOR_PASSWORD" | base64 -w 0)
      - echo "{\"auths\":{\"$HARBOR_HOST\":{\"auth\":\"$AUTH\"}}}" > /kaniko/.docker/config.json
      - TIMESTAMP=$(date +%Y%m%d%H%M%S)
      - /kaniko/executor
        --context "./"
        --dockerfile ./docker/Dockerfile_X64_Dotnet_Bflat
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$DEFAULT_TAG"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$TIMESTAMP-NIGHTLY"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:latest"
        --build-arg IMAGE=harbor.gretzki.ddns.net/docker-cache/debian:latest
        --build-arg BFLAT=https://dwl.gretzki.ddns.net/downloads/bflat-8.0.2-linux-glibc-x64.tar.gz
        --build-arg UPX=https://dwl.gretzki.ddns.net/downloads/upx-4.2.3-amd64_linux.tar.xz
        --build-arg DOTNET=https://dwl.gretzki.ddns.net/downloads/dotnet-sdk-8.0.402-linux-x64.tar.gz
    depends_on: [ buildBaseX64 ]      
  
  - name: deployRuntime
    image: harbor.gretzki.ddns.net/gcrio-cache/kaniko-project/executor:debug
    environment:
      HARBOR_HOST: harbor.gretzki.ddns.net
      HARBOR_PROJECT: containerruntimeglobal
      HARBOR_USERNAME:
        from_secret: harbor_user
      HARBOR_PASSWORD:
        from_secret: harbor_password
      TARGET_PROJECT_NAME: containerruntimeglobal_x64_dotnet_runtime
      DEFAULT_TAG: 24.04_8.0.8
    commands:
      - mkdir -p /kaniko/.docker
      - AUTH=$(echo -n "$HARBOR_USERNAME:$HARBOR_PASSWORD" | base64 -w 0)
      - echo "{\"auths\":{\"$HARBOR_HOST\":{\"auth\":\"$AUTH\"}}}" > /kaniko/.docker/config.json
      - TIMESTAMP=$(date +%Y%m%d%H%M%S)
      - /kaniko/executor
        --context "./"
        --dockerfile ./docker/Dockerfile_X64_Dotnet_RT
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$DEFAULT_TAG"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$TIMESTAMP-NIGHTLY"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:latest"
        --build-arg IMAGE=harbor.gretzki.ddns.net/containerruntimeglobal/containerruntimeglobal_base_x64:24.04
        --build-arg download=https://dwl.gretzki.ddns.net/downloads/aspnetcore-runtime-8.0.8-linux-x64.tar.gz
    depends_on: [ buildBaseX64 ]     

  - name: deployAngular
    image: harbor.gretzki.ddns.net/gcrio-cache/kaniko-project/executor:debug
    environment:
      HARBOR_HOST: harbor.gretzki.ddns.net
      HARBOR_PROJECT: containerruntimeglobal
      HARBOR_USERNAME:
        from_secret: harbor_user
      HARBOR_PASSWORD:
        from_secret: harbor_password
      TARGET_PROJECT_NAME: containerruntimeglobal_x64_angular
      DEFAULT_TAG: 24.04_8.0.8
    commands:
      - mkdir -p /kaniko/.docker
      - AUTH=$(echo -n "$HARBOR_USERNAME:$HARBOR_PASSWORD" | base64 -w 0)
      - echo "{\"auths\":{\"$HARBOR_HOST\":{\"auth\":\"$AUTH\"}}}" > /kaniko/.docker/config.json
      - TIMESTAMP=$(date +%Y%m%d%H%M%S)
      - /kaniko/executor
        --context "./"
        --dockerfile ./docker/Dockerfile_X64_Angular
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$DEFAULT_TAG"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$TIMESTAMP-NIGHTLY"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:latest"
        --build-arg IMAGE=harbor.gretzki.ddns.net/containerruntimeglobal/containerruntimeglobal_base_x64:24.04
        --build-arg NODE_VERSION=20.x
    depends_on: [ buildBaseX64 ]
    
  - name: deployYq
    image: harbor.gretzki.ddns.net/gcrio-cache/kaniko-project/executor:debug
    environment:
      HARBOR_HOST: harbor.gretzki.ddns.net
      HARBOR_PROJECT: containerruntimeglobal
      HARBOR_USERNAME:
        from_secret: harbor_user
      HARBOR_PASSWORD:
        from_secret: harbor_password
      TARGET_PROJECT_NAME: containerruntimeglobal_x64_yq
      DEFAULT_TAG: 24.04_8.0.8
    commands:
      - mkdir -p /kaniko/.docker
      - AUTH=$(echo -n "$HARBOR_USERNAME:$HARBOR_PASSWORD" | base64 -w 0)
      - echo "{\"auths\":{\"$HARBOR_HOST\":{\"auth\":\"$AUTH\"}}}" > /kaniko/.docker/config.json
      - TIMESTAMP=$(date +%Y%m%d%H%M%S)
      - /kaniko/executor
        --context "./"
        --dockerfile ./docker/Dockerfile_X64_Yq
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$DEFAULT_TAG"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$TIMESTAMP-NIGHTLY"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:latest"
        --build-arg IMAGE=harbor.gretzki.ddns.net/containerruntimeglobal/containerruntimeglobal_base_x64:24.04
    depends_on: [ buildBaseX64 ]

  - name: deploySerial
    image: harbor.gretzki.ddns.net/gcrio-cache/kaniko-project/executor:debug
    environment:
      HARBOR_HOST: harbor.gretzki.ddns.net
      HARBOR_PROJECT: containerruntimeglobal
      HARBOR_USERNAME:
        from_secret: harbor_user
      HARBOR_PASSWORD:
        from_secret: harbor_password
      TARGET_PROJECT_NAME: containerruntimeglobal_x64_transfer
      DEFAULT_TAG: 24.04_8.0.8
    commands:
      - mkdir -p /kaniko/.docker
      - AUTH=$(echo -n "$HARBOR_USERNAME:$HARBOR_PASSWORD" | base64 -w 0)
      - echo "{\"auths\":{\"$HARBOR_HOST\":{\"auth\":\"$AUTH\"}}}" > /kaniko/.docker/config.json
      - TIMESTAMP=$(date +%Y%m%d%H%M%S)
      - /kaniko/executor
        --context "./"
        --dockerfile ./docker/Dockerfile_Alpine_Transfer
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$DEFAULT_TAG"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$TIMESTAMP-NIGHTLY"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:latest"
    depends_on: [ buildBaseX64 ]

trigger:
  branch:
    include:
      - main
  event:
    include:
      - cron
      - push
      - custom
        
---

kind: pipeline
type: docker
name: build_arm64

node:
  architecture: arm64
    
platform: 
  arch: arm64

steps:
  - name: deploySerialArm64
    image: harbor.gretzki.ddns.net/gcrio-cache/kaniko-project/executor:debug
    environment:
      HARBOR_HOST: harbor.gretzki.ddns.net
      HARBOR_PROJECT: containerruntimeglobal
      HARBOR_USERNAME:
        from_secret: harbor_user
      HARBOR_PASSWORD:
        from_secret: harbor_password
      TARGET_PROJECT_NAME: containerruntimeglobal_arm64_transfer
      DEFAULT_TAG: 24.04_8.0.8
    commands:
      - mkdir -p /kaniko/.docker
      - AUTH=$(echo -n "$HARBOR_USERNAME:$HARBOR_PASSWORD" | base64 -w 0)
      - echo "{\"auths\":{\"$HARBOR_HOST\":{\"auth\":\"$AUTH\"}}}" > /kaniko/.docker/config.json
      - TIMESTAMP=$(date +%Y%m%d%H%M%S)
      - /kaniko/executor
        --context "./"
        --dockerfile ./docker/Dockerfile_Alpine_Transfer
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$DEFAULT_TAG"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:$TIMESTAMP-NIGHTLY"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$TARGET_PROJECT_NAME:latest"
      
  - name: deployArm64
    image: harbor.gretzki.ddns.net/gcrio-cache/kaniko-project/executor:debug
    environment:
      PROJECT_NAME_ARM64: containerruntimeglobal_dotnet_sdk_arm64
      DEFAULT_TAG: 24.04_8.0.8
      ARM64_DOTNET_SDK: https://dwl.gretzki.ddns.net/downloads/dotnet-sdk-8.0.402-linux-arm64.tar.gz
      HARBOR_HOST: harbor.gretzki.ddns.net
      HARBOR_PROJECT: containerruntimeglobal
      HARBOR_USERNAME:
        from_secret: harbor_user
      HARBOR_PASSWORD:
        from_secret: harbor_password
    commands:
      - mkdir -p /kaniko/.docker
      - AUTH=$(echo -n "$HARBOR_USERNAME:$HARBOR_PASSWORD" | base64 -w 0)
      - echo "{\"auths\":{\"$HARBOR_HOST\":{\"auth\":\"$AUTH\"}}}" > /kaniko/.docker/config.json
      - TIMESTAMP=$(date +%Y%m%d%H%M%S)
      - /kaniko/executor
        --context "./"
        --dockerfile ./docker/Dockerfile_Arm64_Dotnet
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$PROJECT_NAME_ARM64:$DEFAULT_TAG"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$PROJECT_NAME_ARM64:$TIMESTAMP-NIGHTLY"
        --destination "$HARBOR_HOST/$HARBOR_PROJECT/$PROJECT_NAME_ARM64:latest"
        --build-arg SDK_URL=$ARM64_DOTNET_SDK


trigger:
  branch:
    include:
      - main
  event:
    include:
      - push
      - cron
      - custom